#! /usr/bin/env python

from gtk import *
from libglade import *
from nntplib import *
from os import remove
import cPickle
import socket

def on_lista_gruppi1_activate (obj):
    "Mostra la finestra con la lista dei gruppi."
    window2.show()

def init_gruppi():
    "Mostra i gruppi sottoscritti."

    clist1.clear()
    try:
        sottoscritti=open("sottoscritti.txt","r")
    except IOError:
        clist1.append(("Nessuna sottoscrizione",""))
    else:
        gruppi_sottoscritti=cPickle.load(sottoscritti)
        for i in range(len(gruppi_sottoscritti)):
            art_non_letti=open(gruppi_sottoscritti[i][0],"r")
            articoli_non_letti=cPickle.load(art_non_letti)
            art_non_letti.close()
            num_da_leggere=repr(len(articoli_non_letti))
            clist1.append((gruppi_sottoscritti[i][0],num_da_leggere))
            sottoscritti.close()

def on_window2_show (obj):
    "Carica la lista dei gruppi disponibili."
    try:
        out=open("gruppi.txt","r")
    except IOError:
        clist2.append(("unavailable","0"))
    else:
        lista=cPickle.load(out)
        mostra_lista_gruppi(lista)
	out.close()
    mostra_sottoscritti_win2()

def mostra_sottoscritti_win2():
    "Riscrive i gruppi sottoscritti nella finestra 2."
    try:
        sottoscritti=open("sottoscritti.txt","r")
    except IOError:
        clist3.append(["nessun gruppo sottoscritto"])
    else:
        clist3.clear()
        gruppi=cPickle.load(sottoscritti)
	for j in range(len(gruppi)):
	    clist3.append([gruppi[j][0]])

    
def on_button1_clicked(obj):
    "Scarica la lista dei gruppi disponibili sul server."
    global s
    server=entry1.get_text()
    nome_server=open("server","w")
    nome_server.write(server)
    clist2.clear()
    try:
        s=NNTP(server)
    except socket.error:
        clist2.append(("Impossibile connettersi al server",""))
    else:
        statusbar2.push(1," Attendi, sto scaricando la lista dei newsgroup dal server :"+server)
        resp,lista=s.list()
        out=open("gruppi.txt","w")
        mostra_lista_gruppi(lista)
        cPickle.dump(lista,out,1)
        out.close()
	statusbar2.pop(1)
	
def mostra_lista_gruppi(lista):
    "Mostra la lista dei gruppi presenti sul server"
    clist2.freeze()
    for i in range(len(lista)):
        clist2.append( (lista[i][0],lista[i][3]) )
    clist2.thaw()
    
  
def on_clist2_select_row(obj,row,column,event):
    "Memorizza il nome del gruppo da sottoscrivere."
    global gruppo_da_sottoscrivere
    gruppo_da_sottoscrivere=clist2.get_text(row,0)


def on_button2_clicked(obj):
    "Aggiunge un gruppo alla lista dei sottoscritti."
    global gruppo_da_sottoscrivere
    global s

    try:
        nome_server=open("server","r")
    except IOError:
        pass
    else:
        server=nome_server.read()
        try:
            s=NNTP(server)
        except socket.error:
            clist1.append(("Impossibile connettersi al server",""))
        else:
	    resp,count,first,last,name=s.group(gruppo_da_sottoscrivere)
            
	    gruppi_sottoscritti=[]
	    try:
	        sottoscritti=open("sottoscritti.txt","r")
	    except IOError:
	        print "Impossibile aprire il file 'sottoscritti.txt' (lettura)"
		gruppi_sottoscritti.append([gruppo_da_sottoscrivere,last])
	    else:
	        gruppi_sottoscritti=cPickle.load(sottoscritti)
		if gruppo_da_sottoscrivere <> "":
	            gruppi_sottoscritti.append([gruppo_da_sottoscrivere,last])
		sottoscritti.close()
	    try:
		sottoscritti=open("sottoscritti.txt","w")
	    except IOError:
		print "Impossibile aprire il file 'sottoscritti.txt' (scrittura)"
	    else:
	        numero_articoli=spinbutton1.get_value_as_int()
		if numero_articoli>int(count):
		    numero_articoli=int(count)
		gruppi_sottoscritti.sort()
		cPickle.dump(gruppi_sottoscritti,sottoscritti,1)
		sottoscritti.close()
		mostra_sottoscritti_win2()
	
	        art_non_letti=open(gruppo_da_sottoscrivere,"w")
		articoli_non_letti=[]
		first=repr(int(last)-numero_articoli+1)
		resp,msgid=s.xhdr("message-id",first+"-"+last)
		for i in range(len(msgid)):
		    articoli_non_letti.append(msgid[i][1])
                    message=" Sto scaricando i msg-id: "+repr(i)+"/"+repr(len(msgid))
                    statusbar2.push(1,message)
                    while events_pending():
 			mainiteration(FALSE)
		statusbar2.push(1,"Gruppo sottoscritto")
		cPickle.dump(articoli_non_letti,art_non_letti,1)
		art_non_letti.close()
		init_gruppi()

def on_clist3_select_row(obj,row,column,event):
    "Memorizza il nome del gruppo da rimuovere dai sottoscritti."
    print "clist2 row select"
    global gruppo_da_rimuovere
    gruppo_da_rimuovere=clist3.get_text(row,0)
    print gruppo_da_rimuovere, " selezionato"

def on_button5_clicked(obj):
    "Rimuove un gruppo dalla lista dei sottoscritti."
    global gruppo_da_rimuovere
    try:
        sottoscritti=open("sottoscritti.txt","r")
    except IOError:
        print "Impossibile aprire il file 'sottoscritti.txt'"
    else:
        gruppi_sottoscritti=cPickle.load(sottoscritti)
	sottoscritti.close()
	success=0
	i=0
	while (i <len(gruppi_sottoscritti)) and (success==0):
	    print i
	    print gruppi_sottoscritti[i][0]
	    print gruppo_da_rimuovere
	    if gruppo_da_rimuovere==gruppi_sottoscritti[i][0]:
	        success=1
	        gruppi_sottoscritti.remove(gruppi_sottoscritti[i])
		remove(gruppo_da_rimuovere)
	    i=i+1
	try:
	    sottoscritti=open("sottoscritti.txt","w")
	except IOError:
	    print "Impossibile aprire il file 'sottoscritti.txt'"
	else:
	    cPickle.dump(gruppi_sottoscritti,sottoscritti,1)
	    sottoscritti.close()
	    mostra_sottoscritti_win2()
	    init_gruppi()

def on_clist1_select_row(obj,row,column,event):
    "Memorizza il nome del gruppo da leggere."
    global gruppo_da_leggere
    global gruppo_letto
    global articoli_letti
    gruppo_da_leggere=clist1.get_text(row,0)
    print gruppo_da_leggere, " selezionato"
    if gruppo_letto!="":
        art_non_letti=open(gruppo_letto,"r")
	articoli_non_letti=cPickle.load(art_non_letti)
	art_non_letti.close()
	for i in range(len(articoli_letti)):
	    articoli_non_letti.remove(articoli_letti[i])
	art_non_letti=open(gruppo_letto,"w")
	cPickle.dump(articoli_non_letti,art_non_letti,1)
	art_non_letti.close()
	articoli_letti=[]
    mostra_thread()
    init_gruppi()	


def estrai_nick(from_name):
    left=from_name.rfind("<")
    if left!=-1:
        nick=from_name[0:left].strip()
    else:
        left=from_name.rfind("(")
        if left!=-1:
            right=from_name.rfind(")")
            nick=from_name[left+1:right].strip()
        else:
            nick=from_name
    return nick

	
def mostra_thread():
    "Mostra i thred appartenenti al gruppo selezionato per la lettura."
    global s
    global gruppo_letto
    
    gruppo_letto=gruppo_da_leggere
    nome_server=open("server","r")
    server=nome_server.read()
    try:
        s=NNTP(server)
    except socket.error:
        clist1.append(("Impossibile connettersi al server",""))
    else:	   
        resp,count,first,last,name=s.group(gruppo_da_leggere)
        try:
            art_non_letti=open(gruppo_da_leggere,"r")
        except IOError:
            print "Impossibile aprire il file 'art_letti.txt'"
            articoli_non_letti=[]
        else:
            articoli_non_letti=cPickle.load(art_non_letti)
            art_non_letti.close()

            ctree1.clear()
            ctree1.freeze()

            nodo=[]
            msgid_list=[]
	    j=0
            for i in range(len(articoli_non_letti)):
	        try:
		    resp,number,msgid=s.stat(articoli_non_letti[j])
		except NNTPTemporaryError:
		    articoli_non_letti.remove(articoli_non_letti[j])
		    print "rimuovo",articoli_non_letti[j]
		else:
		    resp,from_name=s.xhdr("from",number+"-"+number)
		    resp,ref=s.xhdr("references",number+"-"+number)
		    resp,subj=s.xhdr("subject",number+"-"+number)
		    resp,date=s.xhdr("date",number+"-"+number)
		    nick=estrai_nick(from_name[0][1])
		    if ref[0][1]=="":
			"Radice"
			nodo.append(ctree1.insert_node(None,None,(subj[0][1],nick,date[0][1]),5,None,None,None,None,FALSE,FALSE))
		    else:
			"Ha un padre"
			idx=ref[0][1].rindex("<")    
			last_ref=ref[0][1][idx:len(ref[0][1])]
			k=0
			success=0
			while success==0 and k<j:
			    if msgid_list[k]==last_ref:
				"Ho trovato il padre"
				success=1
				nodo.append(ctree1.insert_node(nodo[k],None,(subj[0][1],nick,date[0][1]),5,None,None,None,None,FALSE,FALSE))
			    else:
				"Non ho trovato il padre"
				k=k+1
			if success==0:
			    nodo.append(ctree1.insert_node(None,None,(subj[0][1],nick,date[0][1]),5,None,None,None,None,FALSE,FALSE))
		    ctree1.node_set_row_data(nodo[j],[msgid,subj[0][1],from_name[0][1],date[0][1]])
		    j=j+1
		    msgid_list.append(msgid)
		    message=" Threading "+repr(j)+"/"+repr(len(articoli_non_letti))+" ..."
		    statusbar1.push(1,message)
		    while events_pending():
			mainiteration(FALSE)
	    ctree1.thaw()
	    art_non_letti=open(gruppo_da_leggere,"w")
	    cPickle.dump(articoli_non_letti,art_non_letti,1)
	    art_non_letti.close()
	    message= gruppo_da_leggere+" selezionato"
	    statusbar1.push(1,message)
        

def on_ctree1_select_row(obj,row,column,event):
    "Memorizza il numero dell'articolo da leggere"
    nodo=ctree1.node_nth(row)
    articolo_da_leggere=ctree1.node_get_row_data(nodo)
    mostra_articolo(articolo_da_leggere)

def mostra_articolo(articolo_da_leggere):
    "Motra l'articolo selezionato"
    global s
    global gruppo_da_leggere
    global articoli_letti

    try:
        art_non_letti=open(gruppo_da_leggere,"r")
    except IOError:
        print "Impossibile aprire il file 'art_letti.txt'"
        art_non_letti=open(gruppo_da_leggere,"w")
        articoli_non_letti=[]
    else:
        articoli_non_letti=cPickle.load(art_non_letti)
        art_non_letti.close()
	art_non_letti=open(gruppo_da_leggere,"w")

    resp,number,id,list=s.body(articolo_da_leggere[0])
#    articoli_non_letti.remove(id)
    if (id in articoli_letti)!=1:
        articoli_letti.append(id)
    cPickle.dump(articoli_non_letti,art_non_letti,1)
    art_non_letti.close()

    from_label.set_text(articolo_da_leggere[2])
    subj_label.set_text(articolo_da_leggere[1])
    date_label.set_text(articolo_da_leggere[3])
   
    try:
        fixed_font =load_font("-monotype-andale mono-medium-r-normal-*-11-*-*-*-m-*-iso8859-15")
    except RuntimeError:
        fixed_font = load_font("-misc-fixed-medium-r-*-*-*-100-*-*-*-*-iso8859-15")
    text1.delete_text(0,-1)
    text1.freeze()
    cmap=window1.get_colormap()
    color_quote=cmap.alloc("blue")
    color_firma=cmap.alloc("darkgrey")
    color_text=cmap.alloc("black")
    color=color_text
    for i in range(len(list)):
        if len(list[i])>0:
            if list[i][0]==">":
                text1.insert(fixed_font,color_quote,None,list[i])
	    elif len(list[i])>1:
	        if (len(list[i])==2 and list[i][0:2]=="--") or (len(list[i])==3 and list[i][0:3]=="-- "):
		    text1.insert(fixed_font,color_firma,None,list[i])
		    color=color_firma
                else:
                    text1.insert(fixed_font,color,None,list[i])
  	text1.insert_defaults("\n")
    text1.thaw()

def on_window2_destroy(obj):
    "Metodo richiamato alla distruzioned della window2"
    print "win2 destroy"
    window2.hide()
    return 1

def on_scarica_nuovi_header1_activate(obj):
    global s
    try:
        nome_server=open("server","r")
    except IOError:
        pass
    else:
        server=nome_server.read()
        s=NNTP(server)
	try:
            sottoscritti=open("sottoscritti.txt","r")
	except IOError:
	    pass
	else:
	    gruppi_sottoscritti=cPickle.load(sottoscritti)
	    sottoscritti.close()
	    sottoscritti=open("sottoscritti.txt","w")
            for i in range(len(gruppi_sottoscritti)):
                art_non_letti=open(gruppi_sottoscritti[i][0],"r")
    	        articoli_non_letti=cPickle.load(art_non_letti)
		art_non_letti.close()
                resp,count,first,last,name=s.group(gruppi_sottoscritti[i][0])
		old_last=int(gruppi_sottoscritti[i][1])
                message=" Aggiorno "+gruppi_sottoscritti[i][0]
		statusbar1.push(1,message)
		if (old_last+1)<=int(last):
		    gruppi_sottoscritti[i][1]=last
		    resp,msgid=s.xhdr("message-id",repr(old_last+1)+"-"+last)
                    for j in range(len(msgid)):
		        message=" Aggiorno "+gruppi_sottoscritti[i][0]+" : articolo "+repr(j)+"/"+repr(len(msgid))
			statusbar1.push(1,message)
	                articoli_non_letti.append(msgid[j][1])
                    art_non_letti=open(gruppi_sottoscritti[i][0],"w")
	            cPickle.dump(articoli_non_letti,art_non_letti,1)
	            art_non_letti.close()	
	    cPickle.dump(gruppi_sottoscritti,sottoscritti,1)
	    sottoscritti.close()
	    statusbar1.push(1,"Gruppi aggiornati")
            init_gruppi()

def on_window1_destroy(obj):
    global articoli_letti
    if len(articoli_letti)>1:
        art_non_letti=open(gruppo_letto,"r")
	articoli_non_letti=cPickle.load(art_non_letti)
	art_non_letti.close()
	for i in range(len(articoli_letti)):
	    articoli_non_letti.remove(articoli_letti[i])
	art_non_letti=open(gruppo_letto,"w")
	cPickle.dump(articoli_non_letti,art_non_letti,1)
	articoli_letti=[]
    mainquit()

        


interface = GladeXML ("newsx.glade")
dic = {"on_lista_gruppi1_activate":on_lista_gruppi1_activate,
       "on_window1_destroy":on_window1_destroy,
       "on_window2_show":on_window2_show,
       "on_button1_clicked":on_button1_clicked,
       "on_button2_clicked":on_button2_clicked,
       "on_button5_clicked":on_button5_clicked,
       "on_clist2_select_row":on_clist2_select_row,
       "on_clist3_select_row":on_clist3_select_row,
       "on_clist1_select_row":on_clist1_select_row,
       "on_ctree1_select_row":on_ctree1_select_row,
       "on_window2_destroy":on_window2_destroy,
       "on_scarica_nuovi_header1_activate":on_scarica_nuovi_header1_activate,
       "on_button3_clicked":on_window2_destroy}

       
interface.signal_autoconnect(dic)
window1=interface.get_widget("window1")
clist1=interface.get_widget("clist1")
window2=interface.get_widget("window2")
entry1=interface.get_widget("entry1")
clist2=interface.get_widget("clist2")
clist3=interface.get_widget("clist3")
ctree1=interface.get_widget("ctree1")
text1=interface.get_widget("text1")
from_label=interface.get_widget("from_label")
subj_label=interface.get_widget("subj_label")
date_label=interface.get_widget("date_label")
statusbar1=interface.get_widget("statusbar1")
statusbar2=interface.get_widget("statusbar2")
spinbutton1=interface.get_widget("spinbutton1")

articoli_letti=[]
gruppo_letto=""
init_gruppi()
mainloop()
